<template>
  <div class="flex flex-col items-center justify-center pointer-events-none">
    <div
      v-if="isLoading"
      key="loader"
      class="bg-blue-100 text-blue-500 rounded-full shadow-md px-4 py-2 flex flex-row items-center mb-4 font-bold"
    >
      <Loader class="w-4" :color="blue" :thickness="8"></Loader>
    </div>
    <div
      v-for="event of events"
      :key="event.id"
      class="rounded-lg shadow-md mb-4 flex flex-col items-stretch overflow-hidden"
    >
      <div
        :class="`bg-${event.color}-100 text-${event.color}-500`"
        class="flex flex-row items-center font-bold rounded-lg px-4 py-2 z-10"
      >
        <i v-if="event.icon" :class="event.icon" class="mr-2"></i>
        {{ event.title }}
        <div
          v-for="action of event.actions || []"
          :key="action.name"
          :class="`text-${event.color}-800`"
          class="pointer-events-auto uppercase tracking-wide ml-4 cursor-pointer select-none"
          @click="actionClick(action, event)"
        >
          {{ action.name }}
        </div>
      </div>
      <div
        v-if="event.body && event.body.length > 0"
        :class="`text-sm px-4 py-2 text-${event.color}-700 bg-${event.color}-200 -mt-8 pt-10`"
      >
        {{ event.body }}
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import Loader from "@/components/Loader.vue";
import Message from "@/models/Message";
import { computed, ref, watch } from "vue";
import tailwindResolved from "@/tailwind.resolved";
import { ApolloAdapter } from "@/models/adapters/ApolloAdapter";

export default {
  components: { Loader },
  setup() {
    const removers = new Map<string, NodeJS.Timeout>();
    watch(
      () => Message.query().getSync(),
      messages =>
        messages.map(message => {
          if (!removers.has(message.id!)) {
            removers.set(
              message.id!,
              setTimeout(() => message.delete(), 5000)
            );
          }
        })
    );

    const isLoading = ref(false);
    let currentTimeout: NodeJS.Timeout | undefined = undefined;
    watch(ApolloAdapter.loading, loading => {
      if (loading > 0) {
        if (!currentTimeout) {
          currentTimeout = setTimeout(() => {
            if (ApolloAdapter.loading.value > 0) {
              isLoading.value = true;
            }
          }, 2000);
        }
      } else {
        if (currentTimeout) {
          clearTimeout(currentTimeout);
          isLoading.value = false;
        }
      }
    });

    return {
      isLoading,
      blue: tailwindResolved.theme.colors.blue[500],
      events: computed(() => Message.query().getSync()),
      actionClick: async (action: { click: () => any }, event: Message) => {
        await action.click();
        await event.delete();
      }
    };
  }
};
</script>

<style></style>
